#ifndef INCLUDED_COM_SUN_STAR_IO_IOEXCEPTION_HPP
#define INCLUDED_COM_SUN_STAR_IO_IOEXCEPTION_HPP

#include "sal/config.h"

#include "com/sun/star/io/IOException.hdl"

#include "com/sun/star/uno/Exception.hpp"
#include "com/sun/star/uno/Type.hxx"
#include "cppu/unotype.hxx"
#include "osl/mutex.hxx"
#include "rtl/instance.hxx"

namespace com { namespace sun { namespace star { namespace io {

inline IOException::IOException() SAL_THROW(())
    : ::com::sun::star::uno::Exception()
{
    ::cppu::UnoType< ::com::sun::star::io::IOException >::get();
}

inline IOException::IOException(const ::rtl::OUString& Message_, const ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >& Context_) SAL_THROW(())
    : ::com::sun::star::uno::Exception(Message_, Context_)
{
    ::cppu::UnoType< ::com::sun::star::io::IOException >::get();
}

IOException::IOException(IOException const & the_other): ::com::sun::star::uno::Exception(the_other) {}

IOException::~IOException() {}

IOException & IOException::operator =(IOException const & the_other) {
    //TODO: Just like its implicitly-defined counterpart, this function definition is not exception-safe
    ::com::sun::star::uno::Exception::operator =(the_other);
    return *this;
}

} } } }

namespace com { namespace sun { namespace star { namespace io { namespace detail {

struct theIOExceptionType : public rtl::StaticWithInit< ::com::sun::star::uno::Type *, theIOExceptionType >
{
    ::com::sun::star::uno::Type * operator()() const
    {
        ::rtl::OUString sTypeName( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.io.IOException") );

        // Start inline typedescription generation
        typelib_TypeDescription * pTD = 0;
        const ::com::sun::star::uno::Type& rSuperType = ::cppu::UnoType< ::com::sun::star::uno::Exception >::get();

        typelib_typedescription_new(
            &pTD,
            (typelib_TypeClass)::com::sun::star::uno::TypeClass_EXCEPTION, sTypeName.pData,
            rSuperType.getTypeLibType(),
            0,
            0 );

        typelib_typedescription_register( (typelib_TypeDescription**)&pTD );

        typelib_typedescription_release( pTD );
        // End inline typedescription generation

        return new ::com::sun::star::uno::Type( ::com::sun::star::uno::TypeClass_EXCEPTION, sTypeName ); // leaked
    }
};

} } } } }

namespace com { namespace sun { namespace star { namespace io {

inline ::com::sun::star::uno::Type const & cppu_detail_getUnoType(SAL_UNUSED_PARAMETER ::com::sun::star::io::IOException const *) {
    return *detail::theIOExceptionType::get();
}

} } } }

inline ::com::sun::star::uno::Type const & SAL_CALL getCppuType(SAL_UNUSED_PARAMETER ::com::sun::star::io::IOException const *) SAL_THROW(()) {
    return ::cppu::UnoType< ::com::sun::star::io::IOException >::get();
}

#endif // INCLUDED_COM_SUN_STAR_IO_IOEXCEPTION_HPP
