#ifndef INCLUDED_COM_SUN_STAR_UNO_RUNTIMEEXCEPTION_HPP
#define INCLUDED_COM_SUN_STAR_UNO_RUNTIMEEXCEPTION_HPP

#include "sal/config.h"

#include "com/sun/star/uno/RuntimeException.hdl"

#include "com/sun/star/uno/Exception.hpp"
#include "com/sun/star/uno/Type.hxx"
#include "cppu/unotype.hxx"
#include "osl/mutex.hxx"
#include "rtl/instance.hxx"

namespace com { namespace sun { namespace star { namespace uno {

inline RuntimeException::RuntimeException() SAL_THROW(())
    : ::com::sun::star::uno::Exception()
{
    ::cppu::UnoType< ::com::sun::star::uno::RuntimeException >::get();
}

inline RuntimeException::RuntimeException(const ::rtl::OUString& Message_, const ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >& Context_) SAL_THROW(())
    : ::com::sun::star::uno::Exception(Message_, Context_)
{
    ::cppu::UnoType< ::com::sun::star::uno::RuntimeException >::get();
}

RuntimeException::RuntimeException(RuntimeException const & the_other): ::com::sun::star::uno::Exception(the_other) {}

RuntimeException::~RuntimeException() {}

RuntimeException & RuntimeException::operator =(RuntimeException const & the_other) {
    //TODO: Just like its implicitly-defined counterpart, this function definition is not exception-safe
    ::com::sun::star::uno::Exception::operator =(the_other);
    return *this;
}

} } } }

namespace com { namespace sun { namespace star { namespace uno { namespace detail {

struct theRuntimeExceptionType : public rtl::StaticWithInit< ::com::sun::star::uno::Type *, theRuntimeExceptionType >
{
    ::com::sun::star::uno::Type * operator()() const
    {
        ::rtl::OUString sTypeName( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.uno.RuntimeException") );

        // Start inline typedescription generation
        typelib_TypeDescription * pTD = 0;
        const ::com::sun::star::uno::Type& rSuperType = ::cppu::UnoType< ::com::sun::star::uno::Exception >::get();

        typelib_typedescription_new(
            &pTD,
            (typelib_TypeClass)::com::sun::star::uno::TypeClass_EXCEPTION, sTypeName.pData,
            rSuperType.getTypeLibType(),
            0,
            0 );

        typelib_typedescription_register( (typelib_TypeDescription**)&pTD );

        typelib_typedescription_release( pTD );
        // End inline typedescription generation

        return new ::com::sun::star::uno::Type( ::com::sun::star::uno::TypeClass_EXCEPTION, sTypeName ); // leaked
    }
};

} } } } }

namespace com { namespace sun { namespace star { namespace uno {

inline ::com::sun::star::uno::Type const & cppu_detail_getUnoType(SAL_UNUSED_PARAMETER ::com::sun::star::uno::RuntimeException const *) {
    return *detail::theRuntimeExceptionType::get();
}

} } } }

inline ::com::sun::star::uno::Type const & SAL_CALL getCppuType(SAL_UNUSED_PARAMETER ::com::sun::star::uno::RuntimeException const *) SAL_THROW(()) {
    return ::cppu::UnoType< ::com::sun::star::uno::RuntimeException >::get();
}

#endif // INCLUDED_COM_SUN_STAR_UNO_RUNTIMEEXCEPTION_HPP
